# 1. PyPDF2
import PyPDF2

file = open("./mlb_predict.pdf", 'rb')
fileReader = PyPDF2.PdfFileReader(file)

fileReader.pageMode()

# 문서의 정보를 읽어드린다
fileReader.documentInfo

# 전체 페이지수를 출력한다
print(fileReader.numPages)

# 첫 번째 페이지 정보를 가져온다
pageObj = fileReader.getPage(0)

# 페이지 정보의 텍스트를 가져온다
text = pageObj.extractText()


# 2. pdftotext
import pdftotext

file = open("./mlb_predict.pdf", 'rb')
fileReader = pdftotext.PDF(file)

print("총 페이지수는 {}입니다.".format(len(fileReader)))

fileReader[0]

# 3. pdftotree
import pdftotree 

pdftotree.parse(pdf_file, html_path = None , model_type = None , model_path = None , favor_figures = True , visualize = False )


# 4. pdfminer
from pdfminer.pdfinterp import PDFResourceManager, PDFPageInterpreter
from pdfminer.converter import HTMLConverter
# from pdfminer.converter import TextConverter
from pdfminer.layout import LAParams
from pdfminer.pdfpage import PDFPage
from io import StringIO

path = "./mlb_predict.pdf"

rsrcmgr = PDFResourceManager()
retstr = StringIO()
codec = 'utf-8'
laparams = LAParams()

f = open('./out.html', 'wb')
device = HTMLConverter(rsrcmgr, f, codec=codec, laparams=laparams)

fp = open(path, 'rb')
interpreter = PDFPageInterpreter(rsrcmgr, device)
password = ""
maxpages = 0 #is for all
caching = True
pagenos=set()
for page in PDFPage.get_pages(fp, pagenos, maxpages=maxpages, password=password,caching=caching, check_extractable=True):
   interpreter.process_page(page)
fp.close()
device.close()
str = retstr.getvalue()
retstr.close()
f.close()

